/*
** $PROJECT: HTDS ARexx scripts
**
** $VER: viewsearch.rexx 40.1 (30.03.97)
**
** $AUTHOR: Stefan Ruppert , Windthorststrasse 5 , 65439 Floersheim , GERMANY
**
** $COPYRIGHT: (C) Copyright 1997 by Stefan Ruppert, All Rights Reserved!
**
** $EMAIL: Stefan.Ruppert@informatik.fh-wiesbaden.de
**
** $HISTORY:
**
** 30.03.97 : 040.001 : initial
*/

Parse Arg args
Options Results

/* --------------------------- needed libraries --------------------------- */

Call AddLib('rexxsupport.library',0,-30,0)
Call AddLib('rexxdossupport.library',0,-30,0)

/* ------------------------ end customize section ------------------------- */

If ReadArgs(args,'DUMMY','VIEWSRC.') Then Do

   buffer = ''
   screen = ''
   nodename = ''
   path     = ''
   mvargs = ''
   'GETATTR OBJECT=OBJECT FIELD=BUFFER   VAR=BUFFER'
   'GETATTR OBJECT=OBJECT FIELD=PATH     VAR=PATH'
   'GETATTR OBJECT=OBJECT FIELD=NODENAME VAR=NODENAME'
   'GETATTR OBJECT=APPLICATION FIELD=SCREEN VAR=SCREEN'

   If screen ~= '' Then
      mvargs = mvargs || ' PUBSCREEN="' || screen || '"'

   tmpfile = 'T:htdsviewsource'
   i = 0
   Do While Exists(tmpfile || i)
      i = i + 1
   End
   tmpfile = tmpfile || i

   portname = 'HTDSVIEWSRC.' || i
   mvargs   = mvargs || ' PORTNAME="' || portname || '"'

   If Open('fh',tmpfile,'w') Then Do
      Call WriteLn('fh',buffer)
      Call Close('fh')
      /* clear var */
      buffer = ''
      ADDRESS COMMAND 'run >NIL: MultiView ' || tmpfile || mvargs

      portname = portname || '.1'
      ADDRESS COMMAND 'WaitForPort ' || portname
      ADDRESS VALUE portname

      title = 'Source of : ' || path
      If nodename ~= '' Then
	 title = title || '/' || nodename

      'SETATTR OBJECT=OBJECT FIELD=TITLE VAR=TITLE'

      Do While Show('P',portname)
	 Call Delay(200)
      End

      ADDRESS COMMAND 'Delete >NIL: ' || tmpfile
   End
End

